// Naam en Van
// Graad 12
// Inligtingstegnologie
// Vraestel 1
// September 2023

unit Vraag2_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, StdCtrls, ComCtrls, ExtCtrls, dbConnection_u, DB,
  ADODB;

type
  TfrmVraag2 = class(TForm)
    btnHerstelDB: TButton;
    pgcVlugInligting: TPageControl;
    tbsSQL: TTabSheet;
    tbsADO: TTabSheet;
    btnVraag2_1_1: TButton;
    btnVraag2_1_2: TButton;
    btnVraag2_1_3: TButton;
    btnVraag2_1_4: TButton;
    btnVraag2_1_5: TButton;
    btnVraag2_2_1: TButton;
    btnVraag2_2_2: TButton;
    redV2_Afvoer: TRichEdit;
    dbgSql: TDBGrid;
    dbgFlights: TDBGrid;
    dbgPilots: TDBGrid;
    lbllFlights: TLabel;
    lblPilots: TLabel;
    cmbV2_2_2_Bestemming: TComboBox;
    pnlSQLGrid: TPanel;
    pnlKnoppies: TPanel;
    pnlBo: TPanel;
    pnlOnder: TPanel;
    pnlBLinks: TPanel;
    pnlBRegs: TPanel;
    procedure btnVraag2_1_1Click(Sender: TObject);
    procedure btnHerstelDBClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnVraag2_1_2Click(Sender: TObject);
    procedure btnVraag2_1_3Click(Sender: TObject);
    procedure btnVraag2_1_4Click(Sender: TObject);
    procedure btnVraag2_1_5Click(Sender: TObject);
    procedure btnVraag2_2_2Click(Sender: TObject);
    procedure btnVraag2_2_1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SetGridColumnWidths(Grid: Tdbgrid);
  end;

var
  frmVraag2: TfrmVraag2;
  // Gegewe kode - MOENIE VERWYDER OF VERANDER NIE
  dbCONN  : TConnection;
  qryInfo : TADOQuery;
  tblVlug, tblVlieenier : TADOTable;

implementation

{$R *.dfm}
{$R+}

procedure TfrmVraag2.btnVraag2_1_1Click(Sender: TObject);
// Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
var
  sSQL1: String;
begin
  /// Tik jou kode hier ///
  sSQL1 := '';

  // Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
  dbCONN.runSQL(sSQL1);
  if length(sSQL1) <> 0 then
    SetGridColumnWidths(dbgSQL);
end;

procedure TfrmVraag2.btnVraag2_1_2Click(Sender: TObject);
// Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
var
   sSQL2: String;
   sLine : String;
begin
  /// Tik jou kode hier ///
  sLine := InputBox('Bestemming','Tik die bestemming in','');

  sSQL2 := '';

  // Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
  dbCONN.runSQL(sSQL2);
  if length(sSQL2) <> 0 then
    SetGridColumnWidths(dbgSQL);
end;

procedure TfrmVraag2.btnVraag2_1_3Click(Sender: TObject);
// Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
var
  sSQL3 : String;
begin
  /// Tik jou kode hier ///
  sSQL3 := '';

  // Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
  dbCONN.runSQL(sSQL3);
  if length(sSQL3) <> 0 then
    SetGridColumnWidths(dbgSQL);
end;

procedure TfrmVraag2.btnVraag2_1_4Click(Sender: TObject);
// Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
var
  sSQL4: String;
begin
  /// Tik jou kode hier ///
  sSQL4 := '';

  // Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
  dbCONN.runSQL(sSQL4);
  if length(sSQL4) <> 0 then
    SetGridColumnWidths(dbgSQL);
end;

procedure TfrmVraag2.btnVraag2_1_5Click(Sender: TObject);
// Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
var
  sSQL5: String;
begin
  /// Tik jou kode hier ///
  sSQL5 := '';

 // Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
 dbCONN.executeSQL(sSQL5,dbgPilots,dbgFlights,dbgSQL);
 if length(sSQL5) <> 0 then
   SetGridColumnWidths(dbgSQL);
end;

procedure TfrmVraag2.btnVraag2_2_1Click(Sender: TObject);
begin
  // Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
  redV2_Afvoer.Clear;
  with tblVlieenier do
    begin
      Open;
      redV2_Afvoer.Lines.Add('Vlieeniers voor verandering: ' + IntToStr(RecordCount));
      First;
      while not (eof) do
        begin
          /// Enter your code below ///
          
        end;
      // Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
      redV2_Afvoer.Lines.Add('Vlieeniers na die verandering: ' + IntToStr(RecordCount));
    end;
end;

procedure TfrmVraag2.btnVraag2_2_2Click(Sender: TObject);
// Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
var
  sBestemming : string;
  iKVL, iPVL, iMVL, iMedeVlieenier : Integer;
begin
 // Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
  redV2_Afvoer.Clear;
  iKVL := 0;
  iPVL := 0;
  iMVL := 0;
  iMedeVlieenier := 0;
  with tblVlug do
    begin
      Open;
      sBestemming := cmbV2_2_2_Bestemming.Text;
      redV2_Afvoer.SelAttributes.Style := [fsBold];
      redV2_Afvoer.Lines.Add(sBestemming);
      redV2_Afvoer.Lines.Add('--------------------------');
      First;
      while not (eof) do
        begin
          /// Tik jou kode hier ///
          

          
        end;
      
    end;
end;

/////////////////////////////////////////////////////////////////
//////////Gegewe kode - MOENIE VERWYDER OF VERANDER NIE//////////
/////////////////////////////////////////////////////////////////
{$REGION 'Setup Code'}
  //Setup DB connections - DO NOT CHANGE!
  procedure TfrmVraag2.btnHerstelDBClick(Sender: TObject);
  begin
    // Restores the Database
    dbCONN.RestoreDatabase(dbgPilots,dbgFlights,dbgSQL);
    // Formatting field datatypes
    tblVlieenier  := dbconn.tblOne;
    tblVlug := dbCONN.tblMany;
    qryInfo   := dbCONN.qryshopping;
	  SetGridColumnWidths(dbgFlights);
 	  SetGridColumnWidths(dbgPilots);
    //SetGridColumnWidths(dbgSQL);
  end;

  procedure TfrmVraag2.FormActivate(Sender: TObject);
  var
    AnsW: string;
  begin
    // Sets up the connection to database and opens the tables.
    dbCONN := TConnection.Create;
    dbCONN.dbConnect;
    tblVlug := dbCONN.tblMany;
    tblVlieenier  := dbCONN.tblOne;
    qryInfo   := dbCONN.qryshopping;
    dbCONN.setupGrids(dbgPilots,dbgFlights,dbgSQL);
    pgcVlugInligting.TabIndex := 0;
    SetGridColumnWidths(dbgFlights);
    SetGridColumnWidths(dbgPilots);
  end;

  procedure TfrmVraag2.FormClose(Sender: TObject; var Action: TCloseAction);
  begin // Disconnects from database and closes all open connections
    dbCONN.dbDisconnect;
  end;

  procedure TfrmVraag2.SetGridColumnWidths(Grid: Tdbgrid);
  const
    DEFBORDER = 10;
  var
    temp, n: Integer;
    lmax: array [0..30] of Integer;
  begin
    with Grid do
    begin
      Canvas.Font := Font;
      for n := 0 to Columns.Count - 1 do
        lmax[n] := Canvas.TextWidth(Fields[n].FieldName) + DEFBORDER;
      Grid.DataSource.DataSet.First;
      while not grid.DataSource.DataSet.EOF do
      begin
        for n := 0 to Columns.Count - 1 do
        begin
          temp := Canvas.TextWidth(trim(Columns[n].Field.DisplayText)) + DEFBORDER;
          if temp > lmax[n] then lmax[n] := temp;
        end; {for}
        grid.DataSource.DataSet.Next;
      end;
      grid.DataSource.DataSet.First;
      for n := 0 to Columns.Count - 1 do
        if lmax[n] > 0 then
          Columns[n].Width := lmax[n];
    end;
  end; {SetGridColumnWidths}
{$ENDREGION}

end.
