// Naam en Van
// Graad 12
// Inligtingstegnologie
// Vraestel 1
// September 2023


//Base Aircraft image sourced from Skypark Secure
//Link:   https://www.skyparksecure.com/blog/fastest-plane-boarding-methods/

unit Vraag4_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ComCtrls, pngImage, ExtCtrls, Spin;

Type
  //Gegewe Kode - MOENIE VERWYDER OF VERANDER NIE
  TArrayBooking = array[0..14,0..4] of Char;

type
  TfrmVraag4 = class(TForm)
    imgV4_Vliegtuig: TImage;
    sgdQ4_Sitplekke: TStringGrid;
    sedV4_RyNommer: TSpinEdit;
    redV4_Afvoer: TRichEdit;
    cmbV4_KolNommer: TComboBox;
    lblA: TLabel;
    lblB: TLabel;
    lblC: TLabel;
    lblD: TLabel;
    lblSitplekNr: TLabel;
    lblBestemming: TLabel;
    cmbV4_1_Bestemming: TComboBox;
    dtpV4_Datum: TDateTimePicker;
    lblDatum: TLabel;
    cmbV4_Tyd: TComboBox;
    lblTyd: TLabel;
    lblNaamVan: TLabel;
    edtV4_NaamVan: TEdit;
    pnlV4_2_Bespreek: TPanel;
    pnlV4_3_Stats: TPanel;
    procedure sgdQ4_SitplekkeDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure cmbV4_1_BestemmingChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pnlV4_2_BespreekClick(Sender: TObject);
    procedure pnlV4_3_StatsClick(Sender: TObject);
    procedure ButtonEnter(Sender : TObject);
    procedure ButtonExit(Sender : TObject);
  private
    { Private declarations }
    //Gegewe Kode - MOENIE VERWYDER OF VERANDER NIE
    ar2Colour  : array[0..14,0..4] of TColor;
    procedure PaintColour;

  public
    { Public declarations }
    //Gegewe Kode - MOENIE VERWYDER OF VERANDER NIE
    ar2Bespreking : TArrayBooking;
  end;

var
  frmVraag4: TfrmVraag4;
  //Gegewe Kode - MOENIE VERWYDER OF VERANDER NIE
  arrKoste  : array[0..4] of Real = (2169,919,699,2439,1169);
  ar2Bloemfontein : TArrayBooking = (
                            ('A','A','I','A','A'),
                            ('B','B','I','B','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('B','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','B','I','A','A'),
                            ('A','A','I','B','A'),
                            ('A','A','I','B','A'),
                            ('A','A','I','A','A'),
                            ('A','B','I','A','A'),
                            ('A','A','I','A','B'),
                            ('A','A','I','A','A'));

  ar2Kaapstad : TArrayBooking = (
                            ('B','B','I','B','B'),
                            ('B','B','I','B','A'),
                            ('B','B','I','B','B'),
                            ('B','B','I','A','A'),
                            ('B','B','I','B','A'),
                            ('B','B','I','B','B'),
                            ('B','B','I','A','B'),
                            ('B','B','I','A','B'),
                            ('B','B','I','A','B'),
                            ('B','A','I','B','A'),
                            ('B','A','I','B','A'),
                            ('B','A','I','A','A'),
                            ('B','B','I','B','A'),
                            ('B','A','I','A','A'),
                            ('A','A','I','A','A'));

  ar2Durban : TArrayBooking = (
                            ('A','A','I','A','B'),
                            ('A','A','I','A','A'),
                            ('A','B','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('B','A','I','B','A'),
                            ('A','A','I','A','B'),
                            ('A','B','I','B','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('B','B','I','B','B'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('B','B','I','B','B'));

  ar2OosLonden : TArrayBooking = (
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'));

  ar2Johannesburg : TArrayBooking = (
                            ('B','B','I','B','A'),
                            ('B','B','I','B','A'),
                            ('B','B','I','B','B'),
                            ('B','B','I','A','A'),
                            ('B','B','I','B','A'),
                            ('B','B','I','B','B'),
                            ('B','B','I','A','B'),
                            ('B','B','I','A','B'),
                            ('B','B','I','A','B'),
                            ('B','A','I','B','A'),
                            ('B','A','I','B','A'),
                            ('B','A','I','A','A'),
                            ('B','B','I','B','A'),
                            ('B','A','I','A','B'),
                            ('A','A','I','B','A'));
implementation

{$R *.dfm}

//////////    Vraag 4.1 - 6 Punte   //////////
procedure TfrmVraag4.cmbV4_1_BestemmingChange(Sender: TObject);

begin
  /// Tik jou kode hier ///

  //Gegewe Kode - MOENIE VERWYDER OF VERANDER NIE 
  PaintColour;
end;


//////////    Vraag 4.2 - 17 Punte   //////////
procedure TfrmVraag4.pnlV4_2_BespreekClick(Sender: TObject);

begin
  redV4_Afvoer.Clear;

  /// Tik jou kode hier ///


  //Gegewe Kode - MOENIE VERWYDER OF VERANDER NIE
  PaintColour;
end;


//////////    Vraag 4.3 - 17 Punte   //////////
procedure TfrmVraag4.pnlV4_3_StatsClick(Sender: TObject);
//Gegewe Kode - MOENIE VERWYDER OF VERANDER NIE
var
  sLine : String;
  iRow, iCol : Integer;
  iBusClass, iEcoClass : Integer;
  rBusPrice, rEcoPrice : Real;
begin
  //Gegewe Kode - MOENIE VERWYDER OF VERANDER NIE  
  redV4_Afvoer.Clear;
  redV4_Afvoer.Paragraph.TabCount := 1;
  redV4_Afvoer.Paragraph.Tab[0] := 10;
  iBusClass := 0;
  iEcoClass := 0;
  rBusPrice := 0;
  rEcoPrice := 0;

  /// Tik jou kode hier ///

end;

/////////////////////////////////////////////////////////////////
//////////Gegewe Kode - MOENIE VERWYDER OF VERANDER NIE//////////
/////////////////////////////////////////////////////////////////
{$REGION 'Setup Code'}
  procedure TfrmVraag4.FormCreate(Sender: TObject);
  var
    iRow, iCol : Integer;
  begin
    redV4_Afvoer.Clear;
    for iRow := 0 to 14 do
      for iCol := 0 to 4 do
        ar2Bespreking[iRow,iCol] := 'I';

    PaintColour;
  end;

  procedure TfrmVraag4.PaintColour;
  var
    iRow: Integer;
    iCol: Integer;
  begin
    for iRow := 0 to 14 do
      for iCol := 0 to 4 do
        begin
          if ar2Bespreking[iRow,iCol] = 'B' then
            ar2Colour[iRow,iCol] := frmVraag4.Color
          else
            if ar2Bespreking[iRow,iCol] = 'A' then
              ar2Colour[iRow,iCol] := clWhite
            else if ar2Bespreking[iRow,iCol] = 'I' then
              ar2Colour[iRow,iCol] := clSilver;
          sgdQ4_Sitplekke.Cells[iCol,iRow] := ar2Bespreking[iRow,iCol];
        end;
  end;

  procedure TfrmVraag4.sgdQ4_SitplekkeDrawCell(Sender: TObject; ACol,
    ARow: Integer; Rect: TRect; State: TGridDrawState);
  var
    iRow: Integer;
    iCol: Integer;
    s : String;
  begin
    with TStringGrid(Sender) do
      begin
        Canvas.Brush.Color := ar2Colour[ARow,ACol];
        Canvas.FillRect(Rect);
        Canvas.Pen.Color := clSilver;
        Canvas.Brush.Style := bsClear;
        // Draw a line from the cell's top-right to its bottom-right:
        Canvas.MoveTo(Rect.Right, Rect.Top);
        Canvas.LineTo(Rect.Right, Rect.Bottom);
        // Make the horizontal line.
        Canvas.LineTo(Rect.Left, Rect.Bottom);
        // The other vertical line.
        Canvas.LineTo(Rect.Left, Rect.Top);
        //Canvas.TextOut(Rect.Left+2,Rect.Top+2,Cells[ACol, ARow]);
      end;
  end;

  procedure TfrmVraag4.ButtonEnter(Sender: TObject);
  var
    pnlTemp : TPanel;
  begin
    pnlTemp := SENDER AS TPanel;
    pnlTemp.Font.Color := frmVraag4.Color;
    pnlTemp.Color  := clWhite;
    pnlTemp.Cursor := crHandPoint;
  end;

  procedure TfrmVraag4.ButtonExit(Sender: TObject);
  var
    pnlTemp : TPanel;
  begin
    pnlTemp := SENDER AS TPanel;
    pnlTemp.Color := frmVraag4.Color;
    pnlTemp.Font.Color := clWhite;
    pnlTemp.Cursor := crDefault;
  end;

{$ENDREGION}

end.
