// Name and Surname
// Grade 12
// Information Technology
// Paper 1
// September 2023


//Class unit
unit Question3ClassDefinition;

interface

uses SysUtils, Math;

type
  TAircraft = class(TObject)
    private
      fName         : String;    // Aircraft name
      fManufacturer : String;    // Manufacturer Name
      fSpeed        : Real;      // Speed in Knots
      fHeight       : Real;      // Height in Feet
      fRange        : Real;      // Range in Miles
      fWeight       : Real;      // Weight in KG
      fWingspan     : Real;      // Wingspan
      fFirepower    : Integer;   // Range value between 1 - 10
      fImageName    : String;    // String value containing image name
      fCountry      : String;    // String value containing country image name
      fDescription  : WideString;// Wide string containing the aircraft description
    public

      function getName : String;
      function getManufacturer : String;
      function getSpeed : Real;
      function getHeight : Real;
      function getRange : Real;
      function getWeight : Real;
      function getWingspan : Real;
      function getFirepower : Integer;
      function getImageName : String;
      function getCountry : String;
      function getDescription : WideString;
end;

implementation

{ TAircraft }

//////////    Question 3.1.1 - 5 Marks    //////////


//////////    Question 3.1.2 - 5 Marks    //////////








/////////////////////////////////////////////////////////////////
//////////    Provided Code - DO NOT DELETE OR ALTER   //////////
/////////////////////////////////////////////////////////////////
function TAircraft.getCountry: String;
begin
  result := fCountry;
end;

function TAircraft.getDescription: WideString;
begin
  Result := fDescription;
end;

function TAircraft.getFirepower: Integer;
begin
  result := fFirepower;
end;

function TAircraft.getHeight: Real;
begin
  result := fHeight;
end;

function TAircraft.getImageName: String;
begin
  result := fImageName;
end;

function TAircraft.getManufacturer: String;
begin
  result := fManufacturer;
end;

function TAircraft.getName: String;
begin
  result := fName;
end;

function TAircraft.getRange: Real;
begin
  result := fRange;
end;

function TAircraft.getSpeed: Real;
begin
  result := fSpeed;
end;

function TAircraft.getWeight: Real;
begin
  result := fWeight;
end;

function TAircraft.getWingspan: Real;
begin
  result := fWingspan;
end;



end.
