// Name and Surname
// Grade 12
// Information Technology
// Paper 1
// September 2023


//Base Aircraft image sourced from Skypark Secure
//Link:   https://www.skyparksecure.com/blog/fastest-plane-boarding-methods/

unit Question4_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ComCtrls, pngImage, ExtCtrls, Spin;

Type
  // Provide Code - DO NOT DELETE OR ALTER //
  TArrayBooking = array[0..14,0..4] of Char;

type
  TfrmQuestion4 = class(TForm)
    imgQ4_Airplane: TImage;
    sgdQ4_Seats: TStringGrid;
    sedQ4_RowNumber: TSpinEdit;
    redQ4_Output: TRichEdit;
    cmbQ4_ColNumber: TComboBox;
    lblA: TLabel;
    lblB: TLabel;
    lblC: TLabel;
    lblD: TLabel;
    lblSeatNo: TLabel;
    lblDestination: TLabel;
    cmbQ4_1_Destination: TComboBox;
    dtpQ4_Date: TDateTimePicker;
    lblDate: TLabel;
    cmbQ4_Time: TComboBox;
    lblTime: TLabel;
    lblNameSur: TLabel;
    edtQ4_NameSur: TEdit;
    pnlQ4_2_Book: TPanel;
    pnlQ4_3_Stats: TPanel;
    procedure sgdQ4_SeatsDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure cmbQ4_1_DestinationChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pnlQ4_2_BookClick(Sender: TObject);
    procedure pnlQ4_3_StatsClick(Sender: TObject);
    procedure ButtonEnter(Sender : TObject);
    procedure ButtonExit(Sender : TObject);
  private
    { Private declarations }

    // Provide Code - DO NOT DELETE OR ALTER //
    ar2Colour  : array[0..14,0..4] of TColor;
    procedure PaintColour;

  public
    { Public declarations }

    // Provide Code - DO NOT DELETE OR ALTER //
    ar2Booking : TArrayBooking;
  end;

var
  frmQuestion4: TfrmQuestion4;
  // Provide Code - DO NOT DELETE OR ALTER //
  arrPrice  : array[0..4] of Real = (2169,919,699,2439,1169);
  ar2Bloemfontein : TArrayBooking = (
                            ('A','A','I','A','A'),
                            ('B','B','I','B','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('B','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','B','I','A','A'),
                            ('A','A','I','B','A'),
                            ('A','A','I','B','A'),
                            ('A','A','I','A','A'),
                            ('A','B','I','A','A'),
                            ('A','A','I','A','B'),
                            ('A','A','I','A','A'));

  ar2CapeTown : TArrayBooking = (
                            ('B','B','I','B','B'),
                            ('B','B','I','B','A'),
                            ('B','B','I','B','B'),
                            ('B','B','I','A','A'),
                            ('B','B','I','B','A'),
                            ('B','B','I','B','B'),
                            ('B','B','I','A','B'),
                            ('B','B','I','A','B'),
                            ('B','B','I','A','B'),
                            ('B','A','I','B','A'),
                            ('B','A','I','B','A'),
                            ('B','A','I','A','A'),
                            ('B','B','I','B','A'),
                            ('B','A','I','A','A'),
                            ('A','A','I','A','A'));

  ar2Durban : TArrayBooking = (
                            ('A','A','I','A','B'),
                            ('A','A','I','A','A'),
                            ('A','B','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('B','A','I','B','A'),
                            ('A','A','I','A','B'),
                            ('A','B','I','B','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('B','B','I','B','B'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('B','B','I','B','B'));

  ar2EastLondon : TArrayBooking = (
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'),
                            ('A','A','I','A','A'));

  ar2Johannesburg : TArrayBooking = (
                            ('B','B','I','B','A'),
                            ('B','B','I','B','A'),
                            ('B','B','I','B','B'),
                            ('B','B','I','A','A'),
                            ('B','B','I','B','A'),
                            ('B','B','I','B','B'),
                            ('B','B','I','A','B'),
                            ('B','B','I','A','B'),
                            ('B','B','I','A','B'),
                            ('B','A','I','B','A'),
                            ('B','A','I','B','A'),
                            ('B','A','I','A','A'),
                            ('B','B','I','B','A'),
                            ('B','A','I','A','B'),
                            ('A','A','I','B','A'));
implementation

{$R *.dfm}

//////////    Question 4.1 - 6 Marks   //////////
procedure TfrmQuestion4.cmbQ4_1_DestinationChange(Sender: TObject);

begin
  /// Enter your code here ///

  // Provide Code - DO NOT DELETE OR ALTER //
  PaintColour;
end;


//////////    Question 4.2 - 17 Marks   //////////
procedure TfrmQuestion4.pnlQ4_2_BookClick(Sender: TObject);

begin
  //Provide Code - DO NOT DELETE OR ALTER
  redQ4_Output.Clear;

  /// Enter your code here ///



  //Provide Code - DO NOT DELETE OR ALTER
  PaintColour;
end;


//////////    Question 4.3 - 17 Marks   //////////
procedure TfrmQuestion4.pnlQ4_3_StatsClick(Sender: TObject);
// Provided code - DO NOT DELETE OR ALTER //
var
  sLine : String;
  iRow, iCol : Integer;
  iBusClass, iEcoClass : Integer;
  rBusPrice, rEcoPrice : Real;

begin
  // Provided code - DO NOT DELETE OR ALTER //
  redQ4_Output.Clear;
  redQ4_Output.Paragraph.TabCount := 1;
  redQ4_Output.Paragraph.Tab[0] := 10;
  iBusClass := 0;
  iEcoClass := 0;
  rBusPrice := 0;
  rEcoPrice := 0;

  /// Enter your code here ///

end;

/////////////////////////////////////////////////////////////////
//////////    Provided Code - DO NOT DELETE OR ALTER   //////////
/////////////////////////////////////////////////////////////////
{$REGION 'Setup Code'}
  procedure TfrmQuestion4.FormCreate(Sender: TObject);
  var
    iRow, iCol : Integer;
  begin
    redQ4_Output.Clear;
    for iRow := 0 to 14 do
      for iCol := 0 to 4 do
        ar2Booking[iRow,iCol] := 'I';

    PaintColour;
  end;

  procedure TfrmQuestion4.PaintColour;
  var
    iRow: Integer;
    iCol: Integer;
  begin
    for iRow := 0 to 14 do
      for iCol := 0 to 4 do
        begin
          if ar2Booking[iRow,iCol] = 'B' then
            ar2Colour[iRow,iCol] := frmQuestion4.Color
          else
            if ar2Booking[iRow,iCol] = 'A' then
              ar2Colour[iRow,iCol] := clWhite
            else if ar2Booking[iRow,iCol] = 'I' then
              ar2Colour[iRow,iCol] := clSilver;
          sgdQ4_Seats.Cells[iCol,iRow] := ar2Booking[iRow,iCol];
        end;
  end;

  procedure TfrmQuestion4.sgdQ4_SeatsDrawCell(Sender: TObject; ACol,
    ARow: Integer; Rect: TRect; State: TGridDrawState);
  var
    iRow: Integer;
    iCol: Integer;
    s : String;
  begin
    with TStringGrid(Sender) do
      begin
        Canvas.Brush.Color := ar2Colour[ARow,ACol];
        Canvas.FillRect(Rect);
        Canvas.Pen.Color := clSilver;
        Canvas.Brush.Style := bsClear;
        // Draw a line from the cell's top-right to its bottom-right:
        Canvas.MoveTo(Rect.Right, Rect.Top);
        Canvas.LineTo(Rect.Right, Rect.Bottom);
        // Make the horizontal line.
        Canvas.LineTo(Rect.Left, Rect.Bottom);
        // The other vertical line.
        Canvas.LineTo(Rect.Left, Rect.Top);
        //Canvas.TextOut(Rect.Left+2,Rect.Top+2,Cells[ACol, ARow]);
      end;
  end;

  procedure TfrmQuestion4.ButtonEnter(Sender: TObject);
  var
    pnlTemp : TPanel;
  begin
    pnlTemp := SENDER AS TPanel;
    pnlTemp.Font.Color := frmQuestion4.Color;
    pnlTemp.Color  := clWhite;
    pnlTemp.Cursor := crHandPoint;
  end;

  procedure TfrmQuestion4.ButtonExit(Sender: TObject);
  var
    pnlTemp : TPanel;
  begin
    pnlTemp := SENDER AS TPanel;
    pnlTemp.Color := frmQuestion4.Color;
    pnlTemp.Font.Color := clWhite;
    pnlTemp.Cursor := crDefault;
  end;

{$ENDREGION}

end.
