// Naam en Van
// Graad 12
// Inligtingstegnologie
// Vraestel 1
// September 2023

unit Vraag1_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, math, ExtCtrls, GIFImg, ComCtrls;

type
  TfrmVraag1 = class(TForm)
    gbxVraag1_1: TGroupBox;
    gbxVraag1_3: TGroupBox;
    shpRegterWiel: TShape;
    gbxVraag1_2: TGroupBox;
    shpLinkerWiel: TShape;
    btnV1_2_2_Op: TButton;
    btnV1_2_3_Af: TButton;
    btnV1_2_1: TButton;
    btnV1_2_4_Toets: TButton;
    pnlV1_2_Ligte: TPanel;
    pnlV1_1_Knoppies: TPanel;
    pnlLinks: TPanel;
    pnlRegs: TPanel;
    rgpV1_1_Lisensie: TRadioGroup;
    btnV1_1_Koste: TButton;
    lblV1_1_Koste: TLabel;
    redV1_3: TRichEdit;
    Q1_3_TopOfDescent: TButton;
    edtV1_3_Eindhoogte: TEdit;
    edtV1_3_Beginhoogte: TEdit;
    edtV1_3_Helling: TEdit;
    lblV1_3_Helling: TLabel;
    lblV1_3_Beginhoogte: TLabel;
    lblV1_3_Eindhoogte: TLabel;
    edtV1_3_Wind: TEdit;
    edtV1_3_EindSpoed: TEdit;
    edtV1_3_BeginSpoed: TEdit;
    lblV1_3_BeginSpoed: TLabel;
    lblV1_3_EindSpoed: TLabel;
    lblV1_3_Wind: TLabel;
    pnlV1_3_RegsToevoer: TPanel;
    pnlV1_3_LinksToevoer: TPanel;
    pnlV1_3_Toevoer: TPanel;
    procedure btnV1_2_2_OpClick(Sender: TObject);
    procedure btnV1_2_3_AfClick(Sender: TObject);
    procedure btnV1_2_1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnV1_2_4_ToetsClick(Sender: TObject);
    procedure btnV1_1_KosteClick(Sender: TObject);
    procedure Q1_3_TopOfDescentClick(Sender: TObject);
  private
    { Private declarations }
    //Gegewe kode - MOENIE VERWYDER OF VERANDER NIE   
    shpVoorsteWiel : TShape;
    procedure Size;
    procedure RandomColours;
  public
    { Public declarations }
  end;

var
  frmVraag1: TfrmVraag1;
  //Gegewe kode - MOENIE VERWYDER OF VERANDER NIE
  arrColours : array[1..2] of TColor = (clRed,clGreen);

implementation

{$R *.dfm}

//////////    Vraag 1.1 - 4 Punte   //////////
procedure TfrmVraag1.btnV1_1_KosteClick(Sender: TObject);
begin
  /// Tik jou kode hier ///


end;

//////////    Vraag 1.2.1 - 6 Punte    //////////
procedure TfrmVraag1.btnV1_2_1Click(Sender: TObject);
begin
  /// Tik jou kode hier ///

end;

//////////    Vraag 1.2.2 - 1 Punt   //////////
procedure TfrmVraag1.btnV1_2_2_OpClick(Sender: TObject);
begin
  // Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
  btnV1_2_1.Click;

  /// Tik jou kode hier ///

end;

//////////    Vraag 1.2.3 - 1 Punt   //////////
procedure TfrmVraag1.btnV1_2_3_AfClick(Sender: TObject);
begin
  // Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
  btnV1_2_1.Click;

  /// Tik jou kode hier ///

end;

//////////    Vraag 1.2.4 - 8 Punte    //////////
procedure TfrmVraag1.btnV1_2_4_ToetsClick(Sender: TObject);
begin
  // Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
  btnV1_2_1.Click;
  RandomColours;

  /// Tik jou kode hier ///


end;

//////////    Vraag 1.2.4 - 20 Punte    //////////
procedure TfrmVraag1.Q1_3_TopOfDescentClick(Sender: TObject);
  // Gegewe kode - MOENIE VERWYDER OF VERANDER NIE //
const DEG_TO_RAD = 0.0174532925;
const NM_TO_FT = 6076.11549;
const FT_TO_NM = 1 / NM_TO_FT;

var
  rGemiddeldeSpoed, rBeginSpoed, rEindSpoed, rVertikaleSpoed, rWind : Real;
  rHelling, rVertikaleSpoed_NM_P_Min : Real;

  rBeginHoogte, rEindHoogte : Real;
  rAfstand, rDeltaHoogte, rDeltaSpoed : Real;
  rGeskatteTyd : Real;
begin
  /// Tik jou kode hier ///


end;

/////////////////////////////////////////////////////////////////
///////// Gegewe Kode - MOENIE VERANDER OF VERWYDER NIE /////////
/////////////////////////////////////////////////////////////////
{$REGION 'Setup code'}
  procedure TfrmVraag1.FormActivate(Sender: TObject);
  begin
    edtV1_3_Beginhoogte.Text := '30000';
    edtV1_3_Eindhoogte.Text   := '5000';
    edtV1_3_Helling.Text    := '3';
    edtV1_3_BeginSpoed.Text    := '300';
    edtV1_3_EindSpoed.Text      := '100';
    edtV1_3_Wind.Text          := '10';
    redV1_3.Clear;
    Size;
  end;

  procedure TfrmVraag1.FormResize(Sender: TObject);
  begin
    Size;
  end;

  procedure TfrmVraag1.RandomColours;
  begin
    shpRegterWiel.Brush.Color := arrColours[Random(2)+1];
    shpLinkerWiel.Brush.Color  := arrColours[Random(2)+1];
    shpVoorsteWiel.Brush.Color := arrColours[Random(2)+1];
  end;

  procedure TfrmVraag1.Size;
  begin
    pnlLinks.Width := frmVraag1.ClientWidth DIV 2;
    gbxVraag1_1.Height := frmVraag1.ClientHeight DIV 2;
    gbxVraag1_2.Height := frmVraag1.ClientHeight DIV 2;
    frmVraag1.Constraints.MinWidth  := 650;
    frmVraag1.Constraints.MinHeight := 400;
    redV1_3.Height := frmVraag1.Height;
    pnlV1_3_LinksToevoer.Width := pnlV1_3_Toevoer.Width DIV 2;
  end;
{$ENDREGION}

end.
