// Name and Surname
// Grade 12
// Information Technology
// Paper 1
// September 2023

unit Question1_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, math, ExtCtrls, GIFImg, ComCtrls;

type
  TfrmQuestion1 = class(TForm)
    gbxQuestion1_1: TGroupBox;
    gbxQuestion1_3: TGroupBox;
    shpRightWheel: TShape;
    gbxQuestion1_2: TGroupBox;
    shpLeftWheel: TShape;
    btnQ1_2_2_Up: TButton;
    btnQ1_2_3_Down: TButton;
    btnQ1_2_1: TButton;
    btnQ1_2_4_Test: TButton;
    pnlQ1_2_Lights: TPanel;
    pnlQ1_2_Buttons: TPanel;
    pnlLeft: TPanel;
    pnlRight: TPanel;
    rgpQ1_1_License: TRadioGroup;
    btnQ1_1_Cost: TButton;
    lblQ1_1_Cost: TLabel;
    redQ1_3: TRichEdit;
    Q1_3_TopOfDescent: TButton;
    edtQ1_3_EndAltitude: TEdit;
    edtQ1_3_StartAltitude: TEdit;
    edtQ1_3_Glideslope: TEdit;
    lblQ1_3_Glideslope: TLabel;
    lblQ1_3_StartAltitude: TLabel;
    lblQ1_3_EndAltitude: TLabel;
    edtQ1_3_Wind: TEdit;
    edtQ1_3_EndSpeed: TEdit;
    edtQ1_3_StartSpeed: TEdit;
    lblQ1_3_StartSpeed: TLabel;
    lblQ1_3_EndSpeed: TLabel;
    lblQ1_3_Wind: TLabel;
    pnlQ1_3_RightInput: TPanel;
    pnlQ1_3_LeftInput: TPanel;
    pnlQ1_3_Input: TPanel;
    procedure btnQ1_2_2_UpClick(Sender: TObject);
    procedure btnQ1_2_3_DownClick(Sender: TObject);
    procedure btnQ1_2_1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnQ1_2_4_TestClick(Sender: TObject);
    procedure btnQ1_1_CostClick(Sender: TObject);
    procedure Q1_3_TopOfDescentClick(Sender: TObject);
  private
    { Private declarations }
    //Provided Code - DO NOT DELETE OR ALTER
    shpFrontWheel : TShape;
    procedure Size;
    procedure RandomColours;
  public
    { Public declarations }
  end;

var
  frmQuestion1: TfrmQuestion1;
  //Provided Code - DO NOT DELETE OR ALTER
  arrColours : array[1..2] of TColor = (clRed,clGreen);

implementation

{$R *.dfm}

//////////    Question 1.1 - 4 Marks   //////////
procedure TfrmQuestion1.btnQ1_1_CostClick(Sender: TObject);
begin
  /// Enter your code below ///

end;

//////////    Question 1.2.1 - 6 Marks    //////////
procedure TfrmQuestion1.btnQ1_2_1Click(Sender: TObject);
begin
  /// Enter your code below ///

end;

//////////    Question 1.2.2 - 1 Mark   //////////
procedure TfrmQuestion1.btnQ1_2_2_UpClick(Sender: TObject);
begin
  // Provided code - DO NOT DELETE OR ALTER //
  btnQ1_2_1.Click;

  /// Enter your code below ///

end;

//////////    Question 1.2.3 - 1 Mark   //////////
procedure TfrmQuestion1.btnQ1_2_3_DownClick(Sender: TObject);
begin
  // Provided code - DO NOT DELETE OR ALTER //
  btnQ1_2_1.Click;

  /// Enter your code below ///

end;

//////////    Question 1.2.4 - 8 Marks    //////////
procedure TfrmQuestion1.btnQ1_2_4_TestClick(Sender: TObject);
begin
  // Provided code - DO NOT DELETE OR ALTER //
  btnQ1_2_1.Click;
  RandomColours;

  /// Enter your code below ///

end;

//////////    Question 1.2.4 - 20 Marks    //////////
procedure TfrmQuestion1.Q1_3_TopOfDescentClick(Sender: TObject);
// Provided code - DO NOT DELETE OR ALTER //
const DEG_TO_RAD = 0.0174532925;
const NM_TO_FT = 6076.11549;
const FT_TO_NM = 1 / NM_TO_FT;

var
  rAverageSpeed, rStartSpeed, rEndSpeed, rVerticalSpeed, rWind : Real;
  rGlideSlope, rVerticalSpeed_NM_P_Min : Real;

  rStartAltitude, rEndAltitude : Real;
  rDistance, rDeltaAltitude, rDeltaSpeed : Real;
  rEstimatedTime : Real;
begin
  /// Enter your code below ///

end;

/////////////////////////////////////////////////////////////////
//////////    Provided Code - DO NOT DELETE OR ALTER   //////////
/////////////////////////////////////////////////////////////////
{$REGION 'Setup code'}
  procedure TfrmQuestion1.FormActivate(Sender: TObject);
  begin
    edtQ1_3_StartAltitude.Text := '30000';
    edtQ1_3_EndAltitude.Text   := '5000';
    edtQ1_3_GlideSlope.Text    := '3';
    edtQ1_3_StartSpeed.Text    := '300';
    edtQ1_3_EndSpeed.Text      := '100';
    edtQ1_3_Wind.Text          := '10';
    redQ1_3.Clear;
    Size;
  end;

  procedure TfrmQuestion1.FormResize(Sender: TObject);
  begin
    Size;
  end;

  procedure TfrmQuestion1.RandomColours;
  begin
    shpRightWheel.Brush.Color := arrColours[Random(2)+1];
    shpLeftWheel.Brush.Color  := arrColours[Random(2)+1];
    shpFrontWheel.Brush.Color := arrColours[Random(2)+1];
  end;

  procedure TfrmQuestion1.Size;
  begin
    pnlLeft.Width := frmQuestion1.ClientWidth DIV 2;
    gbxQuestion1_1.Height := frmQuestion1.ClientHeight DIV 2;
    gbxQuestion1_3.Height := frmQuestion1.ClientHeight DIV 2;
    frmQuestion1.Constraints.MinWidth  := 650;
    frmQuestion1.Constraints.MinHeight := 400;
    redQ1_3.Height := frmQuestion1.Height;
    pnlQ1_3_LeftInput.Width := pnlQ1_3_Input.Width DIV 2;
  end;
{$ENDREGION}

end.
