// Name and Surname
// Grade 12
// Information Technology
// Paper 1
// September 2023

unit Question2_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, StdCtrls, ComCtrls, ExtCtrls, dbConnection_u, DB,
  ADODB;

type
  TfrmQuestion2 = class(TForm)
    btnRestoreDB: TButton;
    pgcFlightInfo: TPageControl;
    tbsSQL: TTabSheet;
    tbsADO: TTabSheet;
    btnQuestion2_1_1: TButton;
    btnQuestion2_1_2: TButton;
    btnQuestion2_1_3: TButton;
    btnQuestion2_1_4: TButton;
    btnQuestion2_1_5: TButton;
    btnQuestion2_2_1: TButton;
    btnQuestion2_2_2: TButton;
    redQ2_Output: TRichEdit;
    dbgSql: TDBGrid;
    dbgFlights: TDBGrid;
    dbgPilots: TDBGrid;
    lbllFlights: TLabel;
    lblPilots: TLabel;
    cmbQ2_2_2_Destination: TComboBox;
    pnlSQLGrid: TPanel;
    pnlButtons: TPanel;
    pnlTop: TPanel;
    pnlBottom: TPanel;
    pnlBLeft: TPanel;
    pnlBRight: TPanel;
    procedure btnQuestion2_1_1Click(Sender: TObject);
    procedure btnRestoreDBClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnQuestion2_1_2Click(Sender: TObject);
    procedure btnQuestion2_1_3Click(Sender: TObject);
    procedure btnQuestion2_1_4Click(Sender: TObject);
    procedure btnQuestion2_1_5Click(Sender: TObject);
    procedure btnQuestion2_2_2Click(Sender: TObject);
    procedure btnQuestion2_2_1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    // Provided code - DO NOT DELETE OR ALTER
    procedure SetGridColumnWidths(Grid: Tdbgrid);
  end;

var
  frmQuestion2: TfrmQuestion2;
  // Provided code - DO NOT DELETE OR ALTER
  dbCONN  : TConnection;
  qryInfo : TADOQuery;
  tblFlight, tblPilot : TADOTable;

implementation

{$R *.dfm}
{$R+}

procedure TfrmQuestion2.btnQuestion2_1_1Click(Sender: TObject);
// Provided code - DO NOT DELETE OR ALTER //
var
  sSQL1: String;
begin
  /// Enter your code below ///
  sSQL1 := '';

  // Provided code - DO NOT DELETE OR ALTER //
  dbCONN.runSQL(sSQL1);
  if length(sSQL1) <> 0 then
    SetGridColumnWidths(dbgSQL);
end;

procedure TfrmQuestion2.btnQuestion2_1_2Click(Sender: TObject);
// Provided code - DO NOT DELETE OR ALTER //
var
   sSQL2: String;
   sLine : String;
begin
  sLine := InputBox('Destination','Enter the destination','');

  /// Enter your code below ///
  sSQL2 := '';

  // Provided code - DO NOT DELETE OR ALTER //
  dbCONN.runSQL(sSQL2);
  if length(sSQL2) <> 0 then
    SetGridColumnWidths(dbgSQL);
end;

procedure TfrmQuestion2.btnQuestion2_1_3Click(Sender: TObject);
// Provided code - DO NOT DELETE OR ALTER //
var
  sSQL3 : String;
begin
  /// Enter your code below ///
  sSQL3 := '';

  // Provided code - DO NOT DELETE OR ALTER //
  dbCONN.runSQL(sSQL3);
  if length(sSQL3) <> 0 then
    SetGridColumnWidths(dbgSQL);
end;

procedure TfrmQuestion2.btnQuestion2_1_4Click(Sender: TObject);
// Provided code - DO NOT DELETE OR ALTER //
var
  sSQL4: String;
begin
  /// Enter your code below ///
  sSQL4 := '';

  // Provided code - DO NOT DELETE OR ALTER //
  dbCONN.runSQL(sSQL4);
  if length(sSQL4) <> 0 then
    SetGridColumnWidths(dbgSQL);
end;

procedure TfrmQuestion2.btnQuestion2_1_5Click(Sender: TObject);
// Provided code - DO NOT DELETE OR ALTER //
var
  sSQL5: String;
begin
  /// Enter your code below ///
  sSQL5 := '';

 // Provided code - DO NOT DELETE OR ALTER //
 dbCONN.executeSQL(sSQL5,dbgPilots,dbgFlights,dbgSQL);
 if length(sSQL5) <> 0 then
   SetGridColumnWidths(dbgSQL);
end;

procedure TfrmQuestion2.btnQuestion2_2_1Click(Sender: TObject);
begin
  // Provided code - DO NOT DELETE OR ALTER //
  redQ2_Output.Clear;
  with tblPilot do
    begin
      Open;
      redQ2_Output.Lines.Add('Pilots before regulation change: ' + IntToStr(RecordCount));
      First;
      while not (eof) do
        begin
          /// Enter your code below ///

        end;
      // Provided code - DO NOT DELETE OR ALTER //
      redQ2_Output.Lines.Add('Pilots after regulation change: ' + IntToStr(RecordCount));
    end;
end;

procedure TfrmQuestion2.btnQuestion2_2_2Click(Sender: TObject);
// Provided code - DO NOT DELETE OR ALTER //
var
  sDestination : string;
  iCPL, iPPL, iMPL, iCoPilot : Integer;
begin
 // Provided code - DO NOT DELETE OR ALTER //
  redQ2_Output.Clear;
  iCPL := 0;
  iPPL := 0;
  iMPL := 0;
  iCoPilot := 0;
  with tblFlight do
    begin
      Open;
      sDestination := cmbQ2_2_2_Destination.Text;
      redQ2_Output.SelAttributes.Style := [fsBold];
      redQ2_Output.Lines.Add(sDestination);
      redQ2_Output.Lines.Add('--------------------------');
      First;
      while not (eof) do
        begin
          /// Enter your code below ///
        end;

    end;
end;

/////////////////////////////////////////////////////////////////
//////////    Provided Code - DO NOT DELETE OR ALTER   //////////
/////////////////////////////////////////////////////////////////
{$REGION 'Setup Code'}
  //Setup DB connections - DO NOT CHANGE!
  procedure TfrmQuestion2.btnRestoreDBClick(Sender: TObject);
  begin
    // Restores the Database
    dbCONN.RestoreDatabase(dbgPilots,dbgFlights,dbgSQL);
    // Formatting field datatypes
    tblPilot  := dbconn.tblOne;
    tblFlight := dbCONN.tblMany;
    qryInfo   := dbCONN.qryshopping;
	  SetGridColumnWidths(dbgFlights);
 	  SetGridColumnWidths(dbgPilots);
    //SetGridColumnWidths(dbgSQL);
  end;

  procedure TfrmQuestion2.FormActivate(Sender: TObject);
  var
    AnsW: string;
  begin
    // Sets up the connection to database and opens the tables.
    dbCONN := TConnection.Create;
    dbCONN.dbConnect;
    tblFlight := dbCONN.tblMany;
    tblPilot  := dbCONN.tblOne;
    qryInfo   := dbCONN.qryshopping;
    dbCONN.setupGrids(dbgPilots,dbgFlights,dbgSQL);
    pgcFlightInfo.TabIndex := 0;
    SetGridColumnWidths(dbgFlights);
    SetGridColumnWidths(dbgPilots);
  end;

  procedure TfrmQuestion2.FormClose(Sender: TObject; var Action: TCloseAction);
  begin // Disconnects from database and closes all open connections
    dbCONN.dbDisconnect;
  end;

  procedure TfrmQuestion2.SetGridColumnWidths(Grid: Tdbgrid);
  const
    DEFBORDER = 10;
  var
    temp, n: Integer;
    lmax: array [0..30] of Integer;
  begin
    with Grid do
    begin
      Canvas.Font := Font;
      for n := 0 to Columns.Count - 1 do
        lmax[n] := Canvas.TextWidth(Fields[n].FieldName) + DEFBORDER;
      grid.DataSource.DataSet.First;
      while not grid.DataSource.DataSet.EOF do
      begin
        for n := 0 to Columns.Count - 1 do
        begin
          temp := Canvas.TextWidth(trim(Columns[n].Field.DisplayText)) + DEFBORDER;
          if temp > lmax[n] then lmax[n] := temp;
        end; {for}
        grid.DataSource.DataSet.Next;
      end;
      grid.DataSource.DataSet.First;
      for n := 0 to Columns.Count - 1 do
        if lmax[n] > 0 then
          Columns[n].Width := lmax[n];
    end;
  end; {SetGridColumnWidths}
{$ENDREGION}

end.
